ChiliProject - Bug # 256: requires_redmine_plugin should defer loading plugins if not all dependencies
are met

Status: Closed Priority: Normal

Author: Holger Just Category: Plugin API

Created: 2011-03-03 Assignee:

Updated: 2011-08-25 Due date:

Remote issue URL: http://www.redmine.org/issues/6324

Affected version: master

Description: @requires_redmine_plugin@ is a nice facility to track inter-plugin dependencies, however, it is useless if | do

not want (or cannot) rename plugins | depend on.

| propose that plugins are deferred and loaded at a later time, if possible.
See attached patch for a proposed solution.

_The patch and this issue is copied from http://www.redmine.org/issues/6324. The patch was developed by
Tim Felgentreff._

Associated revisions

2011-08-25 06:46 pm - Felix SchAxfer

Add deferred loading for plugins which's requirements aren't all met yet #256

History

2011-03-03 03:58 pm - Holger Just
- File 0001-Add-a-Redmine-plugin-locator-to-be-able-to-query-the.patch added

2011-03-05 12:00 pm - Felix Schafer

As | don't have much knowledge of those parts of rails it's OK with me if it's Tim and Holger approved. Is it used in production yet at Finnlabs?

2011-03-05 06:52 pm - Tim Felgentreff
Felix SchA=fer wrote:

> As | don't have much knowledge of those parts of rails it's OK with me if it's Tim and Holger approved. Is it used in production yet at Finnlabs?

We have been deploying with this patch for some time (we also use acts_as_journalized internally, this patch was written at the same time, iirc)

2011-03-06 02:28 am - Eric Davis
Tim:

| can test this out with my redmine_contracts plugin. It requires two other plugins to be loaded first but in the standard A-Z loading they are loaded last.

One question: so if a plugin can't find a dependency, it gets added to @@deferred_plugins@ as long as Rails sees that it's dependency will be loaded
later (@has_plugin?@). Than as each plugin is loaded, all of the @@deferred_plugins@ are loaded again to see if their dependencies are now met. Is
that right?

2011-03-06 08:39 am - Tim Felgentreff

Eric Davis wrote:

> One question: so if a plugin can't find a dependency, it gets added to @@deferred_plugins@ as long as Rails sees that it's dependency will be loaded
later (@has_plugin?@). Than as each plugin is loaded, all of the @@deferred_plugins@ are loaded again to see if their dependencies are now met. Is
that right?

Yes, that's right. So with your @redmine_contracts@ plugin, it will fail to load and add it to @@deferred_plugins[:redmine_overhead]@. Once
@redmine_overhead@ is loaded, it'll try loading @redmine_contracts@, again, and fail, because @redmine_rate@ hasn't been loaded. So it is added
to @@deferred_plugins[:redmine_rate]@ and will be finally loaded after @redmine_rate@ has loaded.

2011-03-07 11:15 pm - Eric Davis

- Assignee set to Eric Davis

Thanks Tim. It also looks like it handles cyclic requirements, which would be other other concern.

I'll review it and do some testing.

2011-08-21 04:31 pm - Felix Schéfer
- Target version set to 2.2.0

- Assignee changed from Eric Davis to Felix Schéfer

- (deleted custom field) set to master

Scheduling this for 2.2.0, this shouldn't break anything and make things easier on plugins that depend on a specific load order. The current status is at

"pull request 99":https://github.com/chiliproject/chiliproject/pull/99

@Tim: Could you have a quick look at the pull request and confirm it? Thanks.

2011-08-21 04:32 pm - Holger Just

@°Felix: When committing, could you please squash the commits?

2011-08-21 11:21 pm - Tim Felgentreff

Felix SchArfer wrote:

> @Tim: Could you have a quick look at the pull request and confirm it? Thanks.
Affirmative :) Will be good to see this finally merged

2011-08-22 10:03 am - Felix Schéfer

Eric Davis wrote:

> It also looks like it handles cyclic requirements, which would be other other concern.

| tested this and found out that though it won't die/hang on cyclic requirements, it silently fails to load all the plugins in the cycle. | added detection and
an error for cyclic dependencies in "a80e846":https://github.com/finnlabs/chiliproject/commit/a80e846fc29afa7abe03ea0110a0238e23853f0b, it would
be great if anyone could review that part so that | can finally merge it.

For anyone wanting the whole picture, "pull request 99":https://github.com/chiliproject/chiliproject/pull/99 still has it.

2011-08-22 10:03 am - Felix Schéfer

- Assignee deleted (Felix Schéfer)

2011-08-25 04:47 pm - Felix Schéafer

- Status changed from Ready for review to Closed

Merged in commit:a24a24e, thanks Tim.
